console.log('functions.js');

/////// Fonctions générales //////////////

//Saisie de nombre entier ou a virgule obligatoire //
function saisieNombre( message, valeurParDefaut) {
    var saisie;
    do {
        saisie = window.prompt (message, valeurParDefaut);

        if(saisie != null ) // Sinon nombre est transformé en NaN par parseFloat, et on reste coincé dans la boucle
            saisie = parseFloat(saisie);
    }
    while ( (isNaN(saisie)) && (saisie != null) );

    return saisie;
}

// Renvoie un nombre aléatoire
function nombreAleatoire(min, max) {
    return Math.floor(Math.random() * (max - min + 1)) + min;
}


////////////////// Projet Carnet d'adresse ///////
function onSubmit(event) {
  // On empêche le formulaire de relancer la page
  event.preventDefault();


  // Récupérer le choix de l'utilisateur
  var radioValue = $("input[name='lesBoutonsRadio']:checked").val();
  // console.log(radioValue);

  var lurlEnfonctionDuChoixDeLutilisateur;

  // En fonction du choix de l'utilisateur
  switch (radioValue) {
    case "html":
      // console.log("html");
      lurlEnfonctionDuChoixDeLutilisateur = "php/1-get-html-article.php";
      recupererEtAfficherResultat( lurlEnfonctionDuChoixDeLutilisateur );

      break;

    case "json":
      // console.log("json");
      lurlEnfonctionDuChoixDeLutilisateur = "php/2-get-json-data.php";
      recupererEtAfficherJson(lurlEnfonctionDuChoixDeLutilisateur);

      break;

      case "flims":
        // console.log("flims");
        lurlEnfonctionDuChoixDeLutilisateur = "php/3-get-html-movies.php";
        recupererEtAfficherResultat( lurlEnfonctionDuChoixDeLutilisateur );

        break;

      case "meteo":

        // Récupérer le contenu éventuel du champ texte
        var villeFournieParLUtilisateur = $('#villeMeteo').val();

        // Note pour le de plus tard, vérifier que l'utliser n'a rentré que des lettres, en cas de problèlmes, bisous, j'espère que tu vas bien.

        // Si le champ n'est pas bien rempli
        if(villeFournieParLUtilisateur.length <= 0 || typeof villeFournieParLUtilisateur != "string"){
          // On affiche une ville par défaut
          villeFournieParLUtilisateur = "Paris,fr";
        }

        // Structure de l'url de l'api Open Weather Map
        // http://api.openweathermap.org/data/2.5/weather
        //   ?q=paris,fr
        //   &units=metric
        //   &lang=fr
        //   &APPID=9d9f577c8f3a9b3ca773992f12d0e95d

        // Variables de l'API
        // var ville           = "paris,fr";
        var unités          = "metric";
        var langue          = "fr";
        var appId           = "9d9f577c8f3a9b3ca773992f12d0e95d";

        // Création de l'url
        var urlConstruite   = 'http://api.openweathermap.org/data/2.5/weather';

        // Ajouter la ville
        // urlConstruite       += '?q='      + ville;
        urlConstruite       += '?q='      + villeFournieParLUtilisateur;
        // Ajouter les unités
        urlConstruite       += '&units='  + unités;
        // Ajouter la langue
        urlConstruite       += '&lang='   + langue;
        // Ajouter l'appId'
        urlConstruite       += '&APPID='  + appId;

        recupererEtAfficherMeteo(urlConstruite);

        break;



    default:
      alert('La vie ca marche pas comme ca wesh');
      break;

  }
}



function afficherJson(leContenuAAfficher){
  // console.log(parsedTartopaum);

  // Le parser
  var parsedTartopaum = JSON.parse(leContenuAAfficher);

  // console.log(parsedTartopaum);

  // Gérer son affichage
  // Créer une caractères, qui va permettre de créer l'affichage complet, avant de mettre a jour le html
  var aAfficher = "<ul>";

  for (var i = 0; i < parsedTartopaum.length; i++) {
    var contact = parsedTartopaum[i];

    // console.log(contact); // {firstName: "Tom", phone: "0102030405"}

    aAfficher += "  <li>                                    ";
    aAfficher += "      <h3>" + contact.firstName + "</h3>  ";
    aAfficher += "      <p>"  + contact.phone     + "</p>   ";
    aAfficher += "  </li>                                   ";

  }

  aAfficher += "</ul>";

  // Mettre a jour mon html
  $('.resultat').html(aAfficher);
}



// Afficher un résulatat simple : pas de traitement, on l'injecte dans notre html
function recupererEtAfficherResultat(lurlEnfonctionDuChoixDeLutilisateur){
  // Récupérer le contenu
  $.ajax(
    {
      // Le fichier qu'on va chercher, plus spécifiquement, le contenu affiché par le fichier
      url      : lurlEnfonctionDuChoixDeLutilisateur,

      // La fonction qui sera appelée au cas ou le fichier a bien été trouvé
      //                   Le paramètre, rempli automatiquement, contiendra le retour de l'ajax (le contenu du fichier)
      success  : function(result) {
        // Afficher le contenu
        $('.resultat').html(result);
      }
    }
  );
}



// Récupérer du contenu json, et appeler la fonction d'affichage
function recupererEtAfficherJson(lurlEnfonctionDuChoixDeLutilisateur){
  // Récupérer le contenu
  $.ajax(
    {
      // Le fichier qu'on va chercher, plus spécifiquement, le contenu affiché par le fichier
      url      : lurlEnfonctionDuChoixDeLutilisateur,

      // La fonction qui sera appelée au cas ou le fichier a bien été trouvé
      //                   Le paramètre, rempli automatiquement, contiendra le retour de l'ajax (le contenu du fichier)
      success  : function(result) {
        afficherJson( result );
      }
    }
  );
}



// Récupérer du contenu meteo, et appeler la fonction d'affichage
function recupererEtAfficherMeteo(lurlEnfonctionDuChoixDeLutilisateur){
  // Récupérer le contenu
  $.ajax(
    {
      // Le fichier qu'on va chercher, plus spécifiquement, le contenu affiché par le fichier
      url      : lurlEnfonctionDuChoixDeLutilisateur,

      // La fonction qui sera appelée au cas ou le fichier a bien été trouvé
      //                   Le paramètre, rempli automatiquement, contiendra le retour de l'ajax (le contenu du fichier)
      success  : function(result) {
        console.log( result );

        afficherMeteo(result);
      }
    }
  );
}



function afficherMeteo(donnéesMétéos) {

  var descriptionMeteo  = donnéesMétéos.weather[0].description;
  var tempMeteo         = donnéesMétéos.main.temp;
  var villeMeteo        = donnéesMétéos.name;

  // Gestion de l'icône
  var iconIdMeteo       = donnéesMétéos.weather[0].icon;
  // https://openweathermap.org/weather-conditions
  var iconUrlMeteo      = "http://openweathermap.org/img/w/" + iconIdMeteo + ".png";
  var iconImgMeteo      = '<img src="' + iconUrlMeteo + '" />';

  // Création de ma chaîne à afficher
  var leTempsQuIlFait   = "<p>Aujourd'hui sur " + villeMeteo + ", il fait " + tempMeteo + "°, et le temps est " + descriptionMeteo + " : " + iconImgMeteo + "</p>";

  $('.resultat').html(leTempsQuIlFait);

}
